#include <apop.h>
gsl_rng *r;

void plot_draws(apop_model *m, char *outfile){
  int   draws   = 2e3;
  apop_data *d = apop_data_alloc(0, draws,1);
    for(size_t i=0; i < draws; i++)
        apop_draw(apop_data_ptr(d, i, 0), r, m);
    apop_model *h3  = apop_estimate(d, apop_histogram);
    apop_histogram_print(h3, outfile);
}

int main(){ 
    r = apop_rng_alloc(1);
    apop_db_open("data-wb.db");
    apop_data *pops = apop_query_to_data("select population+0.0 p from pop where p>500");
    apop_model *h   = apop_estimate(pops, apop_histogram);
    apop_histogram_print(h, "out.hist");
    plot_draws(apop_estimate(pops, apop_lognormal), "lognormal_fit");
    printf("set xrange [0:2e5]; set yrange [0:0.12]; \n \
            plot 'out.hist' with boxes, 'lognormal_fit' with lines\n");
}
