#include <apop.h>

apop_model sin_sq_model;

void do_search(int m, char *name){
  double        p[] = {0};
  double        result;
    Apop_settings_add(&sin_sq_model, apop_mle, starting_pt, p);
    Apop_settings_add(&sin_sq_model, apop_mle, method, m);
    apop_model *out  = apop_maximum_likelihood(NULL, sin_sq_model);
    result           = gsl_vector_get(out->parameters->vector, 0);
    printf("The %s algorithm found %g.\n", name, result);
}

int main(){
    apop_opts.verbose ++;
    Apop_settings_add_group(&sin_sq_model, apop_mle, &sin_sq_model);
    do_search(APOP_SIMPLEX_NM, "N-M Simplex");
    do_search(APOP_CG_FR, "F-R Conjugate gradient");
    do_search(APOP_SIMAN, "Simulated annealing");
    do_search(APOP_RF_NEWTON, "Root-finding");
}
