#include <apop.h> 

int main(){
    apop_db_open("data-climate.db");
    apop_data *data  = apop_query_to_data("select pcp from precip");
    apop_model *h = apop_estimate(data, apop_histogram);
    apop_histogram_normalize(h);
    remove("out.h"); remove("out.k");
    apop_histogram_print(h, "out.h");
    apop_model *kernel = apop_model_set_parameters(apop_normal, 0., 0.1);
    apop_model *k = apop_model_copy(apop_kernel_density);
    Apop_settings_add_group(k, apop_kernel_density, NULL, h, kernel, NULL);
    apop_histogram_print(k, "out.k");
    printf("plot 'out.h' with lines title 'data', 'out.k' with lines title 'smoothed'\n");
}
